<?php
/*
OekakiPoteto 5.x Copyright 2000-2002 RanmaGuy (Theo Chakkapark, http://suteki.nu) and Marcello Basta-Forte (http://marcello.cellosoft.com). Modification to the files are permitted as long as my name remains on the files.

Wacintaki Poteto 1.0 modifications Copyright 2004 Marc "Waccoon" Leveille, http://www.NineChime.com/Wacintosh.htm
*/


// Debug prevents deletion of work files
$debug = 0;


include('common.php');


header('Content-type: text/html');
echo <<<EOF
<html>
<head>
	<title>OekakiPoteto Update</title>

	<style type="text/css" title="default">
		<!--
		p {
			margin-left: 2em;
		}
		-->
	</style>
</head>

<body>


EOF;
//<?

/*
	It's necessary to check the dbconn, config, and SQL version numbers to do a proper upgrade.  OekakiPoteto does not support this, so we'll have to ask the user what version they have installed.
*/
if ($_POST['updatetype'] == '') {
	ask_version();
}


// Call correct function & verify
function print_OK() {
	global $debug;

echo <<<EOF
	If you have multiple boards, make sure each board is at the current version.<br />
	<br />
	Click the button below to finalize the update.  This will clean up the updater files and prevent security problems.<br />

	<form action="index.php" method="post">

EOF;
	if ($debug == 0) echo'		<input name="action" type="hidden" value="secure" />';
echo <<<EOF
		<input name="submit" type="submit" value="Secure updater and go to the BBS" />
	</form>

EOF;
}
$bad  = 'Check your server permissions and the <em>dbconn.php</em> file and try again';

if ($_POST['updatetype'] == 'noWac') {
	echo "	<p>\n";
	if (OP040_to_OP051()) {
		print_OK();
	} else {
		web_line($bad);
	}
	echo "	</p>\n";
}
if ($_POST['updatetype'] == 'from_4.x') {
	echo "	<p>\n";
	if (OP040_to_OP051()) {
		if (OP051_to_Wac010()) {
			print_OK();
		} else {
			web_line($bad);
		}
	} else {
		web_line($bad);
	}
	echo "	</p>\n";
}
if ($_POST['updatetype'] == 'from_5.x') {
	echo "	<p>\n";
	if (OP051_to_Wac010()) {
		print_OK();
	} else {
		web_line($bad);
	}
	echo "	</p>\n";
}


echo <<<EOF
</body>
</html>
EOF;
//<?


// Finis
exit;



// ==================================================================
// Functions
//
function ask_version() {
	// Asks user for upgrade type

	if (! @include('config.php')) {
echo <<<EOF
	<p>
		Warning:  missing config file!  Update cannot continue.<br />
		Make sure your old board is working properly before running the updater.<br />
	</p>

EOF;
//<?
		return 0;
	}

	if (! @include('dbconn.php')) {
echo <<<EOF
	<p>
		Warning:  missing database file!  Update cannot continue.<br />
		Make sure your old board is working properly before running the updater.
	</p>

EOF;
//<?
		return 0;
	}


echo <<<EOF
	<h1>Wacintaki Poteto Update</h1>

	<h4>Make sure you've deleted your old template and language files before copying the new ones and running this updater.  Your old templates and language files WILL NOT WORK with this version of Oekaki Poteto.</h4>

	<hr />

	<form name="form1" action="update.php" method="post">
		<h4>Please select the type of update you need to perform.</h4>
		<p>
			<input name="updatetype" type="radio" value="from_5.x" checked />From v5.x to Wacintaki v1.0<br />
			<input name="updatetype" type="radio" value="from_4.x" />From v4.x to Wacintaki v1.0<br />
			<input name="updatetype" type="radio" value="noWac" />From v4.x to v5.1.0a<br />
		</p>

		<h4>Select a new default template (ignored if updating to Poteto v5.1.0a).</h4>
		<p>
			<select name="updatetemplate">

EOF;
//<?

if ($handle = opendir('templates')) {
	/* This is the correct way to loop over the directory. */
	while (false !== ($file = readdir($handle))) {
		if(substr($file,-4) == '.php'){
?>
				<option value="<?=substr($file,0,-4)?>"><?=substr($file,0,-4);?></option>
<?
		}
	}
	closedir($handle);
}

echo <<<EOF
			</select>
		</p>

		<h4>Enter your name as the BBS Author.</h4>
		<p>
			<input name="BBSauthor" type="text" value="" />
		</p>

		<h4>Is this strictly an adult BBS?</h4>
		<p>
			<select name="BBSadult">
				<option value="yes">Yes</option>
				<option value="no" selected>No</option>
			</select>
		</p>

		<h4>Begin the update...</h4>
		<p>
			<input name="submit" type="submit" value="Update" />
		</p>
	</form>
EOF;
//<?
	return 1;
}



function OP040_to_OP051() {
	global $debug;

	// Poteto 4.x to Poteto 5.1a
	$newversion = '5.1.0a';

	web_line('Update from v4.x to 5.1.0a...');

	/* We need to do the following:
		1) Add new values to config file:
			(UNKNOWN)

		2) Remove values from config file:
			(UNKNOWN)

		3) Add values to database:
			TABLE: oekakimailbox
			TABLE: oekakimisc
			TABLE: oekakichatmod
			TABLE: oekakichatmodusers

		4) Remove files if they exist:
			count
			install.php
	*/


	//Upgrade DB
	include('dbconn.php');

	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakichat RENAME ".$OekakiPoteto_MemberPrefix."oekakichat");
	sql_check($result);
	@$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakionline RENAME ".$OekakiPoteto_MemberPrefix."oekakionline");
	sql_check($result);
	@$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakikill RENAME ".$OekakiPoteto_MemberPrefix."oekakikill");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekakionline ADD onlineboard TEXT NOT NULL");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki CHANGE commcount commcount INT(11) DEFAULT '0' NOT NULL");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki CHANGE piccount piccount INT(11) DEFAULT '0' NOT NULL");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekakionline CHANGE OID OID BIGINT(255) NOT NULL AUTO_INCREMENT");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekakionline CHANGE locale locale VARCHAR(30) DEFAULT NULL ");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakidta CHANGE PIC_ID PIC_ID int(11) DEFAULT '0' NOT NULL ");
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakidta CHANGE edittime edittime int(20) unsigned default NULL");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakidta ADD postlock tinyint(4) NOT NULL default '0' ");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki ADD age text");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_Prefix."oekakidta ADD animation tinyint(2) default '0'"); 
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki ADD gender text");
	sql_check($result);
	$result = mysql_query("UPDATE ".$OekakiPoteto_Prefix."oekakidta SET postlock='1'");
	sql_check($result);
	$result = mysql_query("CREATE TABLE ".$OekakiPoteto_MemberPrefix."oekakimailbox (MID int(11) NOT NULL auto_increment, sender varchar(255) NOT NULL default '', reciever varchar(255) NOT NULL default '', subject text NOT NULL,  body longtext NOT NULL,  mstatus smallint(10) NOT NULL default '0', senddate datetime NOT NULL default '0000-00-00 00:00:00', PRIMARY KEY (MID), KEY sender(sender), KEY reciever (reciever))"); 
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki ADD language TEXT NOT NULL ");
	sql_check($result);
	$result = mysql_query("UPDATE ".$OekakiPoteto_MemberPrefix."oekaki SET language='english'");
	sql_check($result);
	$result = mysql_query("CREATE TABLE ".$OekakiPoteto_Prefix."oekakimisc (MiscID int(11) NOT NULL auto_increment, miscname varchar(255) NOT NULL default '', miscvalue bigint(255) NOT NULL,  PRIMARY KEY  (MiscID),  KEY miscname (miscname))");
	sql_check($result);


	// Upgrade count
	$fp2 = @fopen('count', 'r');
	if ($fp2) {
		$resno = fread ($fp2, filesize ('count'));
		fclose($fp2);
	}
	trim($resno);
	$result = mysql_query("INSERT INTO ".$OekakiPoteto_Prefix."oekakimisc VALUES (1,'piccount','$resno')");
	sql_check($result);
	$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki ADD picview TINYINT(11) DEFAULT '0' NOT NULL");
	sql_check($result);


	// Update chat
	$result = mysql_query("CREATE TABLE ".$OekakiPoteto_MemberPrefix."oekakichatmod (usrname varchar(255) NOT NULL default '',  command varchar(32) NOT NULL default 'MESSAGE',  comment tinytext NOT NULL,  posttime timestamp(14) NOT NULL,  hostname text NOT NULL,  email varchar(255) default NULL,  url text,  IP text NOT NULL,  postname varchar(50) NOT NULL default '',  PRIMARY KEY (posttime)) TYPE=MyISAM;");
	sql_check($result);

	$result = mysql_query("CREATE TABLE ".$OekakiPoteto_MemberPrefix."oekakichatmodusers (usrname varchar(255) NOT NULL, lastmessage timestamp(14) NOT NULL, afk ENUM('no','yes') NOT NULL default 'no', PRIMARY KEY (usrname)) TYPE=MyISAM;");
	sql_check($result);

	mysql_close($dbconn);


	// Upgrade config
	include('config.php');
	// chmod('config.php', 0666);
	// chmod('dbconn.php', 0666);

	$fp = @fopen('config.php', 'w');
	if ($fp) {
		fwrite($fp, "<?php\n\n \$saltenc=\"".$saltenc."\"; \n \$OPpics=\"".$OPpics."\"; \n \$killuser=\"".$killuser."\"; \n \$template=\"".$template."\"; \n \$BBStitle=\"".$BBStitle."\"; \n \$eaddr=\"".$eaddr."\"; \n \$okurl=\"".$okurl."\"; \n \$apostrophes=\"".$apostrophes."\"; \n \$pstore=\"".$pstore."\"; \n \$ppage=\"".$ppage."\"; \n \$approval=\"".$approval."\"; \n \$drawaccess=\"".$drawaccess."\"; \n \$animationaccess=\"".$animationaccess."\"; \n \$xCanvas=\"".$xCanvas."\"; \n \$yCanvas=\"".$yCanvas."\"; \n \$xDefault=\"".$xDefault."\"; \n \$yDefault=\"".$yDefault."\"; \n \$chatMax=\"".$chatMax."\"; \n \$chatDisp=\"".$chatDisp."\"; \n \$language=\""."english"."\"; \n \$archivedir=\"".$archivedir."\"; \n \$guestpost=\"".$guestpost."\";\n \$anisize=\"".$anisize."\"; \n \$jpgcompression=\""."no"."\"; \n \$jpgcompressqual=\""."100"."\";\n\n?>");
		fclose($fp);
	} else {
		web_line('ERROR: Could not create new <em>config.php</em> file!');
	}


	// Remove install.php if it exists
	@unlink('count');
	if (!$debug) @unlink('install.php');


	//command to attempt to chmod the picture directory
	@chmod($OPpics, 0777);


	// Complete!
	web_line('Update finished: OP 5.1.0a');
	web_line('');

	return 1;
}
// END OP040_to_OP051



function OP051_to_Wac010() {
	global $debug;

	// Poteto 5.1a to Wacintaki Poteto 1.0
	// Updated: July 17th, 2004
	$newversion = 'Wac1.0';

	web_line('Update from v5.1a to Wacintaki Poteto 1.0...');

	/* We need to do the following:
		1) Add new values to config file:
			$BBSauthor        = '';
			$OPPrefix         = '';
			$requireart       = 'no';
			$templatepath     = 'templates';
			$resourcepath     = 'resource';
			$perpage          = '25';
			$CFG_previewImg   = 'preview.png';
			$CFG_previewTitle = 'Canvas Preview';
			$xMin             = '50';
			$yMin             = '50';
			$aCanvas          = '250000'; (Unused for the moment)
			$useChat          = 'yes'; (Default for Poteto 5.1)

		2) Remove values from config file:
			$apostrophes

		3) Change all names to reflect new filename prefix.
			(Not working yet.  Use blank prefix for now.)

		4) Update templates
			Ensure default is set, and change all user accounts to the default template.

		5) Verify that the chosen language file is available in Wacintaki Poteto.

		6) Remove files if they exist:
			announce.php
			arecover.php
			button.gif
			editnews.php
			flagchk.php
			install.php
			MgLine.zip
			news.php
			noteBBSa.php
			oekakiBBSa.php
			README.txt
			redirect.php
			tdesign.php
			tedit.php
			tedita.php
			template.php
			test.php
			tnew.php
			tnewa.php
			versionchk.php
	*/


	// Upgrade config
	include('config.php');
	strip_path($OPpics);
	strip_path($templatepath);
	strip_path($resourcepath);

	if ($perpage == '') {
		// Only set defaults if not already updated.
		$BBSauthor = '';
		$BBSadult = 'no';
		$OPPrefix = '';
		$perpage = 25;
		$xMin = 50;
		$yMin = 50;
		$aCanvas = 250000;
		$requireart = 'no';
		$CFG_previewImg   = 'preview.png';
		$CFG_previewTitle = 'Canvas Preview';
		$templatepath = 'templates';
		$resourcepath = 'resource';
		$useChat = 'yes';
	}

	if ($_POST['updatetemplate'] != '') {
		$template  = $_POST['updatetemplate'];
		$BBSauthor = $_POST['BBSauthor'];
		$BBSadult  = $_POST['BBSadult'];
	}

	// Fix Wacintaki alpha version
	if (file_exists('resource') && $resourcepath == '') {
		$resourcepath = 'resource';
	}

	$main_configuration = <<<EOF
<?php // Include only

	\$BBStitle  = '$BBStitle';
	\$BBSauthor = '$BBSauthor';
	\$BBSadult  = '$BBSadult';
	\$eaddr     = '$eaddr';
	\$okurl     = '$okurl';

	\$saltenc    = '$saltenc';
	\$OPpics     = '$OPpics';
	\$archivedir = '$archivedir';
	\$OPPrefix   = '$OPPrefix';

	\$killuser   = '$killuser';
	\$approval   = '$approval';
	\$requireart = '$requireart';
	\$guestpost  = '$guestpost';
	\$drawaccess = '$drawaccess';
	\$animationaccess = '$animationaccess';

	\$language     = '$language';
	\$template     = '$template';
	\$templatepath = '$templatepath';
	\$resourcepath = '$resourcepath';

	\$pstore  = '$pstore';
	\$ppage   = '$ppage';
	\$perpage = '$perpage';

	\$CFG_previewImg   = '$CFG_previewImg';
	\$CFG_previewTitle = '$CFG_previewTitle';
	\$xDefault = '$xDefault';
	\$yDefault = '$yDefault';
	\$xCanvas  = '$xCanvas';
	\$yCanvas  = '$yCanvas';
	\$xMin     = '$xMin';
	\$yMin     = '$yMin';
	\$aCanvas  = '$aCanvas';
	\$anisize  = '$anisize';

	\$useChat  = '$useChat';
	\$chatMax  = '$chatMax';
	\$chatDisp = '$chatDisp';

	\$jpgcompression  = '$jpgcompression';
	\$jpgcompressqual = '$jpgcompressqual';

?>
EOF;
//<?


	// Write config file
	$fp = @fopen ('config.php', 'w');
	if ($fp) {
		fwrite ($fp, $main_configuration);
		fclose ($fp);
	} else {
		web_line('ERROR:  Could not open config file for writing.  Check your server permissions');

		// Nothing done yet, so we can bail safely
		return 0;
	}


	// Update templates/languages
	{
		include('dbconn.php');
		$newtemplate = slashit($_POST['updatetemplate']);
		if ($newtemplate == '') {
			$newtemplate = 'Default';
		}

		// Template
		$result = mysql_query("ALTER TABLE ".$OekakiPoteto_MemberPrefix."oekaki CHANGE templatesel templatesel VARCHAR(255) DEFAULT '".$newtemplate."'");
		sql_check($result);

		$result = mysql_query("UPDATE ".$OekakiPoteto_MemberPrefix."oekaki SET templatesel='".$newtemplate."'");
		sql_check($result);


		// Language
		if (file_exists ('language/'.$language.'.php')) {
			$result = mysql_query("UPDATE ".$OekakiPoteto_MemberPrefix."oekaki SET language='".$language."'");
		} else {
			$result = mysql_query("UPDATE ".$OekakiPoteto_MemberPrefix."oekaki SET language='english'");
		}
		sql_check($result);


		mysql_close($dbconn);
	}


	// Verify CHMOD
	@chmod($OPpics, 0777);
	@chmod('templates', 0777);


	// Remove files if they exist
	{
		@unlink('announce.php');
		@unlink('arecover');
		@unlink('button.gif');
		@unlink('editnews.php');
		@unlink('flagchk.php');
		if (!$debug) @unlink('install.php');
		@unlink('MgLine.zip');
		@unlink('news.php');
		@unlink('noteBBSa.php');
		@unlink('oekakiBBSa.php');
		@unlink('README.txt');
		@unlink('redirect.php');
		@unlink('tdesign.php');
		@unlink('tedit.php');
		@unlink('tedita.php');
		@unlink('template.php');
		@unlink('test.php');
		@unlink('tnew.php');
		@unlink('tnewa.php');
		@unlink('versionchk.php');
	}


	//Update version numbers
	$fp = @fopen('version.php', 'w');
	if ($fp) {
		fwrite($fp, "<?php\n\n	\$version = '$newversion';\n\n?>");
	}


	// Complete!
	web_line('Update finished: Wacintaki Poteto v1.0');
	web_line('');

	return 1;
}
// END OP051_to_Wac010

?>